Merge "Bug 129 RIFT-15122"
[osm/SO.git] / BUILD.sh
1 #!/usr/bin/env bash
2 #
3 # Copyright 2016 RIFT.IO Inc
4 #
5 # Licensed under the Apache License, Version 2.0 (the "License");
6 # you may not use this file except in compliance with the License.
7 # You may obtain a copy of the License at
8 #
9 # http://www.apache.org/licenses/LICENSE-2.0
10 #
11 # Unless required by applicable law or agreed to in writing, software
12 # distributed under the License is distributed on an "AS IS" BASIS,
13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14 # See the License for the specific language governing permissions and
15 # limitations under the License.
16 #
17 # Author(s): Jeremy Mordkoff, Lezz Giles
18 # Creation Date: 08/29/2016
19 #
20 #
21
22 # BUILD.sh
23 #
24 # This is a top-level build script for RIFT.io
25 #
26 # Arguments and options: use -h or --help
27 #
28 # dependencies -- requires sudo rights
29
30 # Defensive bash programming flags
31 set -o errexit # Exit on any error
32 trap 'echo ERROR: Command failed: \"$BASH_COMMAND\"' ERR
33 set -o nounset # Expanding an unset variable is an error. Variables must be
34 # set before they can be used.
35
36 ###############################################################################
37 # Options and arguments
38
39 # There
40 params="$(getopt -o suhb: -l install-so,install-ui,no-mkcontainer,build-ui:,help --name "$0" -- "$@")"
41 if [ $? != 0 ] ; then echo "Failed parsing options." >&2 ; exit 1 ; fi
42
43 eval set -- $params
44
45 installSO=false
46 installUI=false
47 runMkcontainer=true
48 UIPathToBuild=
49
50 while true; do
51 case "$1" in
52 -s|--install-so) installSO=true; shift;;
53 -u|--install-ui) installUI=true; shift;;
54 -b|--build-ui) shift; UIPathToBuild=$1; shift;;
55 --no-mkcontainer) runMkcontainer=false; shift;;
56 -h|--help)
57 echo
58 echo "NAME:"
59 echo " $0"
60 echo
61 echo "SYNOPSIS:"
62 echo " $0 -h|--help"
63 echo " $0 [-s] [-u|-b PATH-TO-UI-REPO] [PLATFORM_REPOSITORY] [PLATFORM_VERSION]"
64 echo
65 echo "DESCRIPTION:"
66 echo " Prepare current system to run SO and UI. By default, the system"
67 echo " is set up to support building SO and UI; optionally, either or"
68 echo " both SO and UI can be installed from a Debian package repository."
69 echo
70 echo " -s|--install-so: install SO from package"
71 echo " -u|--install-ui: install UI from package"
72 echo " -b|--build-ui PATH-TO-UI-REPO: build the UI in the specified repo"
73 echo " --no-mkcontainer: do not run mkcontainer, used for debugging script"
74 echo " PLATFORM_REPOSITORY (optional): name of the RIFT.ware repository."
75 echo " PLATFORM_VERSION (optional): version of the platform packages to be installed."
76 echo
77 exit 0;;
78 --) shift; break;;
79 *) echo "Not implemented: $1" >&2; exit 1;;
80 esac
81 done
82
83 if $installUI && [[ $UIPathToBuild ]]; then
84 echo "Cannot both install and build the UI!"
85 exit 1
86 fi
87
88 if [[ $UIPathToBuild && ! -d $UIPathToBuild ]]; then
89 echo "Not a directory: $UIPathToBuild"
90 exit 1
91 fi
92
93 # Turn this on after handling options, so the output doesn't get cluttered.
94 set -x # Print commands before executing them
95
96 ###############################################################################
97 # Find the platform
98 PYTHON=python
99 if [[ ! -f /usr/bin/python ]]; then
100 PYTHON=python3
101 fi
102
103 if $PYTHON -mplatform | grep -qi fedora; then
104 PLATFORM=fc20
105 elif $PYTHON -mplatform | grep -qi ubuntu; then
106 PLATFORM=ub16
107 else
108 echo "Unknown platform"
109 exit 1
110 fi
111
112 ###############################################################################
113 # Set up repo and version
114
115 if [[ $PLATFORM == ub16 ]]; then
116 PLATFORM_REPOSITORY=${1:-OSM}
117 PLATFORM_VERSION=${2:-4.3.1.0.50309}
118 elif [[ $PLATFORM == fc20 ]]; then
119 PLATFORM_REPOSITORY=${1:-OSM} # change to OSM when published
120 PLATFORM_VERSION=${2:-4.3.1.0.50310}
121 else
122 echo "Internal error: unknown platform $PLATFORM"
123 exit 1
124 fi
125
126 ###############################################################################
127 # Main block
128
129 # must be run from the top of a workspace
130 cd $(dirname $0)
131
132 # inside RIFT.io this is an NFS mount
133 # so just to be safe
134 test -h /usr/rift && sudo rm -f /usr/rift
135
136 if [[ $PLATFORM == ub16 ]]; then
137 # enable the right repos
138 curl http://repos.riftio.com/public/xenial-riftware-public-key | sudo apt-key add -
139 sudo curl -o /etc/apt/sources.list.d/${PLATFORM_REPOSITORY}.list http://buildtracker.riftio.com/repo_file/ub16/${PLATFORM_REPOSITORY}/
140 sudo apt-get update
141
142 # and install the tools
143 sudo apt remove -y rw.toolchain-rwbase tcpdump
144 sudo apt-get install -y rw.tools-container-tools rw.tools-scripts python
145 elif [[ $PLATFORM == fc20 ]]; then
146 # get the container tools from the correct repository
147 sudo rm -f /etc/yum.repos.d/private.repo
148 sudo curl -o /etc/yum.repos.d/${PLATFORM_REPOSITORY}.repo \
149 http://buildtracker.riftio.com/repo_file/fc20/${PLATFORM_REPOSITORY}/
150 sudo yum install --assumeyes rw.tools-container-tools rw.tools-scripts
151 else
152 echo "Internal error: unknown platform $PLATFORM"
153 exit 1
154 fi
155
156 # enable the OSM repository hosted by RIFT.io
157 # this contains the RIFT platform code and tools
158 # and install of the packages required to build and run
159 # this module
160 if $runMkcontainer; then
161 sudo apt-get install -y libxml2-dev libxslt-dev
162 sudo /usr/rift/container_tools/mkcontainer --modes build --modes ext --repo ${PLATFORM_REPOSITORY}
163 fi
164
165
166 if [[ $PLATFORM == ub16 ]]; then
167 # install the RIFT platform code:
168 sudo apt-get install -y --allow-downgrades rw.toolchain-rwbase=${PLATFORM_VERSION} \
169 rw.toolchain-rwtoolchain=${PLATFORM_VERSION} \
170 rw.core.mgmt-mgmt=${PLATFORM_VERSION} \
171 rw.core.util-util=${PLATFORM_VERSION} \
172 rw.core.rwvx-rwvx=${PLATFORM_VERSION} \
173 rw.core.rwvx-rwdts=${PLATFORM_VERSION} \
174 rw.automation.core-RWAUTO=${PLATFORM_VERSION} \
175 rw.core.rwvx-rwha-1.0=${PLATFORM_VERSION}
176
177 sudo chmod 777 /usr/rift /usr/rift/usr/share
178
179 if $installSO; then
180 sudo apt-get install -y \
181 rw.core.mc-\*=${PLATFORM_VERSION}
182 fi
183
184 if $installUI; then
185 sudo apt-get install -y \
186 rw.ui-about=${PLATFORM_VERSION} \
187 rw.ui-logging=${PLATFORM_VERSION} \
188 rw.ui-skyquake=${PLATFORM_VERSION} \
189 rw.ui-accounts=${PLATFORM_VERSION} \
190 rw.ui-composer=${PLATFORM_VERSION} \
191 rw.ui-launchpad=${PLATFORM_VERSION} \
192 rw.ui-debug=${PLATFORM_VERSION} \
193 rw.ui-config=${PLATFORM_VERSION} \
194 rw.ui-dummy_component=${PLATFORM_VERSION}
195 fi
196 elif [[ $PLATFORM == fc20 ]]; then
197
198 temp=$(mktemp -d /tmp/rw.XXX)
199 pushd $temp
200
201 # yum does not accept the --nodeps and --replacefiles options so we
202 # download first and then install
203 yumdownloader rw.toolchain-rwbase-${PLATFORM_VERSION} \
204 rw.toolchain-rwtoolchain-${PLATFORM_VERSION} \
205 rw.core.mgmt-mgmt-${PLATFORM_VERSION} \
206 rw.core.util-util-${PLATFORM_VERSION} \
207 rw.core.rwvx-rwvx-${PLATFORM_VERSION} \
208 rw.core.rwvx-rwha-1.0-${PLATFORM_VERSION} \
209 rw.core.rwvx-rwdts-${PLATFORM_VERSION} \
210 rw.automation.core-RWAUTO-${PLATFORM_VERSION}
211
212 # Install one at a time so that pre-installed packages will not cause a failure
213 for pkg in *rpm; do
214 # Check to see if the package is already installed; do not try to install
215 # it again if it does, since this causes rpm -i to return failure.
216 if rpm -q $(rpm -q -p $pkg) >/dev/null; then
217 echo "WARNING: package already installed: $pkg"
218 else
219 sudo rpm -i --replacefiles --nodeps $pkg
220 fi
221 done
222
223 popd
224 rm -rf $temp
225
226 # this file gets in the way of the one generated by the build
227 sudo rm -f /usr/rift/usr/lib/libmano_yang_gen.so
228
229
230 sudo chmod 777 /usr/rift /usr/rift/usr/share
231
232 if $installSO; then
233 sudo apt-get install -y \
234 rw.core.mc-\*-${PLATFORM_VERSION}
235 fi
236
237 if $installUI; then
238 sudo apt-get install -y \
239 rw.ui-about-${PLATFORM_VERSION} \
240 rw.ui-logging-${PLATFORM_VERSION} \
241 rw.ui-skyquake-${PLATFORM_VERSION} \
242 rw.ui-accounts-${PLATFORM_VERSION} \
243 rw.ui-composer-${PLATFORM_VERSION} \
244 rw.ui-launchpad-${PLATFORM_VERSION} \
245 rw.ui-debug-${PLATFORM_VERSION} \
246 rw.ui-config-${PLATFORM_VERSION} \
247 rw.ui-dummy_component-${PLATFORM_VERSION}
248 fi
249
250 else
251 echo "Internal error: unknown platform $PLATFORM"
252 exit 1
253 fi
254
255 # install some base files used to create VNFs
256 test -d /usr/rift/images || mkdir /usr/rift/images
257 for file in Fedora-x86_64-20-20131211.1-sda-ping.qcow2 Fedora-x86_64-20-20131211.1-sda-pong.qcow2 Fedora-x86_64-20-20131211.1-sda.qcow2; do
258 test -f /usr/rift/images/$file || curl -o /usr/rift/images/$file http://repo.riftio.com/releases/open.riftio.com/4.3.1/$file
259 done
260
261 # If you are re-building SO, you just need to run
262 # these two steps
263 if ! $installSO; then
264 make -j16
265 sudo make install
266 fi
267
268 if [[ $UIPathToBuild ]]; then
269 make -C $UIPathToBuild -j16
270 sudo make -C $UIPathToBuild install
271 fi
272
273 echo "Creating Service ...."
274 sudo $(dirname $0)/create_launchpad_service
275